function [res_classdfa] = classfda(x,y,lv)

  // distributed under the CeCILL-C license
  // copyright INRA-IRSTEA 2013

  // vérification que y est bien disjonctif
  [testdisj]=isdisj(y);
  if testdisj=='F' then
      y=conj2dis(y);
  end

  [n,q] = size(x);
  n2=size(y,1);
  if n~= n2 then error('not the same number of observations in x and y');
  end;


  // determination de l'inertie interclasse
  b = x'*y*pinv(y'*y)*y'*x;

  // determination de l'inertie totale
  t = x'*x;
  m = pinv(t);

  // calcul des vecteurs propres et valeurs propres
  vmatSTSB = m*b;
  [U,S,V]=svd(vmatSTSB);
  
  lv2=min(lv,size(V,2));

  res_classdfa.loadings=V(:,1:lv2);


   
endfunction
