function [conf_pcent,err_classif,err_classif_byclass,not_class,not_class_bycl] = conf_obs2pcent(conf_obs,varargin)

  // distributed under the CeCILL-C license
  // copyright INRA-IRSTEA 2013

  nbcl=size(conf_obs,1);
  classes_total=sum(conf_obs,'r');
  conf_pcent=conf_obs;
  for j=1:nbcl;
    if classes_total(j)>100* %eps then
      conf_pcent(:,j)=100*conf_pcent(:,j)/classes_total(j); 
    end
  end

  // erreur moyenne de classification, en p.cent 
  obs_total=sum(conf_obs);     // somme de ttes les valeurs de conf
  
  if obs_total>10*%eps then                                                        
    err_classif=100*(1-trace(conf_obs)/obs_total);
  
  
  // erreur de classification par classe, en p.cent
  conf2=conf_pcent-eye(conf_pcent).*conf_pcent;   // on enlève la diagonale
  err_classif_byclass=sum(conf2,'r')';

  if  argn(2)==2 then
    nobs_bycl=varargin(1);
  
    // pourcentage de non classés par classe                                        
    for i=1:nbcl;                                                                                   
      if nobs_bycl(i)~=0 then
        not_class_bycl(i)=100*(nobs_bycl(i)-classes_total(i))./nobs_bycl(i);
      else
        not_class_bycl(i)=0;
      end
    end 
     
    // pourcentage de non classés
    not_class=100* sum(nobs_bycl-classes_total)/ obs_total;

  end
  
  else
    err_classif=0;
    err_classif_byclass=zeros(nbcl,1);
    not_class=0;
    not_class_bycl=zeros(nbcl,1);
  end
 
  
 
endfunction
