function [res_appli]=daapply(model,xv,varargin);
    
  // distributed under the CeCILL-C license
  // copyright INRA-IRSTEA 2013
     
  // prédiction
  xv1=div(xv);
  xval=xv1.d;
  [n,q]=size(xval);
  table1=model.conf_cv(1).d;
  nbcl=size(table1,1);
  lv=size(model.err.d,1);
  xcal=model.xcal.d;
  ycal=model.ycal.d;
  [nxc,qxc]=size(xcal);
  [nyc,qyc]=size(ycal);
  yval0=zeros(n,qyc);
  
  if q~=qxc then error('not the same numbers of variables')
  end



  // CAS DES METHODES DE REGRESSION -------------------------
  
  // classtestxx calcule le modèle ce qui peut être long; on a déjà
  // ces infos (loadings, metric) donc on utilise plutôt memberpred  
  
  if isfield(model,'loadings') then
      
    // extraction des infos du modèle
    metric=model.classif_metric;
    scale=model.scale;
    class=model.classif_opt;
    seuil=model.threshold;
    ploads=model.loadings.d; 
    if isfield(model,'model_metric') then
      m=model.model_metric.d;
    else
      m=eye(q,q);
    end 
 
    // gestion de scaling: centrage / centrage-standardisation
    vm = mean(xcal,'r');
    vst = stdev(xcal,'r');
 
    for i=1:size(xcal,2);          //gestion des variances nulles... 
      if vst(i)<10*%eps then vst(i)=0.0000000001;
      end
    end
 
    if scale=='cs' then
      xcal =  ( xcal - ones(size(xcal,1),1)  * vm ) ./ ( ones(size(xcal,1),1) * vst );
      xval = ( xval - ones(n,1) * vm ) ./ ( ones(n,1) * vst );
     
    elseif scale=='c' then
      xcal =  xcal  - ones(size(xcal,1),1) * vm;
      xval = xval - ones(n,1) * vm;
    end;

    // prédiction pour le jeu de test
    yp=zeros(n,nbcl,lv);   
    
    for i=1:lv;
      xcal_scores=xcal*m*ploads(:,1:i)*inv(ploads(:,1:i)'*m*ploads(:,1:i));
      xval_scores=xval*m*ploads(:,1:i)*inv(ploads(:,1:i)'*m*ploads(:,1:i)); 

      [pr]=memberpred(xcal_scores,ycal,xval_scores,yval0,metric,class);   
      //[pr]=memberpred(xcal,ycal,xval,yval0,metric,class);
      
      // décision d'appartenance à une classe: PROBA. MAX avec la classe
      [prm,ind] = max(pr,'c');
      
      ypred = conj2dis(ind,nbcl,'C');
      ypred(prm<seuil,:) = 0;     // possible que des obs. ne soient rattachées à aucune classe! 
      
      yp(:,:,i)=ypred;
    end

    // cas où yv est connue
    if argn(2)==3 then
      yv=varargin(1);
      yv1=div(yv);
      yval=yv1.d;
      test=isconj(yval);
      if test=='T' then
        yval=conj2dis(yval);
      else
        yval=str2conj(yval);
        yval=conj2dis(yval);
      end
      
 
      confus=zeros(nbcl,nbcl,lv);
      confus_pcent=confus; 
      err_test=zeros(lv,1);
      err_test_bycl=zeros(lv,nbcl);      
      nonclasse=zeros(lv,1);
      nonclasse_bycl=zeros(lv,nbcl);
      
      for i=1:lv;
        confus_i=yp(:,:,i)'*yval; 
        confus(:,:,i)=confus_i;            
        [confusi_pcent,erri,erribycl,nci,nci_bycl]=conf_obs2pcent(confus_i,sum(yval,'r'));
        confus_pcent(:,:,i)=confusi_pcent;
        err_test(i)=erri;
        err_test_bycl(i,:)=erribycl';
        nonclasse(i)=nci;        
        nonclasse_bycl(i,:)=nci_bycl';
      end
    end
  
    // sorties
    
    res_appli.ypred=list();
    for i=1:lv;
      ypredi.d=yp(:,:,i);
      ypredi.i=xv1.i;
      ypredi.v='CL'+string([1:1:nbcl])';
      ypredi=div(ypredi);
      res_appli.ypred(i)=ypredi;
    end

//    res_appli.ypred.d=[];  // indispensable pour hypermatrices
//    res_appli.ypred.d=yp;
//    res_appli.ypred.l=xv1.i;
//    res_appli.ypred.c='CL'+string([1:1:nbcl])';
//    res_appli.ypred.v='DV'+string([1:1:lv])';

    if  argn(2)>=3 then
      res_appli.conf_test_nobs=list();
      for i=1:lv;
        confus_i.d=confus(:,:,i); 
        confus_i.i='pred_'+ string([1:1:size(yval,2)]');
        confus_i.v='ref_'+ string([1:1:size(yval,2)]');
        confus_i=div(confus_i);
        res_appli.conf_test_nobs(i)=confus_i;
      end      
//      res_appli.confm_test_nobs.d=[];
//      res_appli.confm_test_nobs.d=confus;  
//      res_appli.confm_test_nobs.l='pred_'+ yv1.v;
//      res_appli.confm_test_nobs.c='ref_'+ yv1.v;
//      res_appli.confm_test_nobs.v='DV'+string([1:1:lv]');
      
      res_appli.conf_test=list();
      for i=1:lv;
        conftesti.d=confus_pcent(:,:,i);
        conftesti.i='pred_'+ string([1:1:size(yval,2)]');
        conftesti.v='ref_'+ string([1:1:size(yval,2)]');
        conftesti=div(conftesti);
        res_appli.conf_test(i)=conftesti;
      end
//      res_appli.confm_test.d=[];
//      res_appli.confm_test.d=confus_pcent;  
//      res_appli.confm_test.l='pred_'+ yv1.v;
//      res_appli.confm_test.c='ref_'+ yv1.v;
//      res_appli.confm_test.v='DV'+string([1:1:lv]');   
      
      res_appli.err_test.d=err_test;
      res_appli.err_test.i='DV'+string([1:1:lv]');
      res_appli.err_test.v='error of prediction, p.cent';
     
      
      res_appli.err_test=div(res_appli.err_test);
  
      res_appli.errbycl_test.d=err_test_bycl;
      res_appli.errbycl_test.i='DV'+string([1:1:lv]'); 
      res_appli.errbycl_test.v='CL'+string([1:1:nbcl])';
      res_appli.errbycl_test=div(res_appli.errbycl_test); 
 
      res_appli.notclassed.d=nonclasse;
      res_appli.notclassed.i='DV'+string([1:1:lv])';
      res_appli.notclassed.v='not classed, p.cent of all the observations';
      res_appli.notclassed=div(res_appli.notclassed);
    
      res_appli.notclassed_bycl.d=nonclasse_bycl;
      res_appli.notclassed_bycl.i='DV'+string([1:1:lv])';
      res_appli.notclassed_bycl.v='CL'+string([1:1:nbcl])';
      res_appli.notclassed_bycl=div(res_appli.notclassed_bycl);
    end
  
  // CAS DES AUTRES METHODES: knn pour l'instant  ----------------------------------
  elseif ~isfield(model,'loadings') then 
    
    nn=model.knn;
    scale=model.scale;
    func2='classtest'+ model.method;
    
    execstr(msprintf('[classif]=%s(xcal,ycal,xval,yval0,nn,scale)',func2));
    

    if argn(2)==3 then    // yv est donné 
      yv=varargin(1);
      [test,yv1]=isdiv(yv);
      yval=yv1.d;
      test=isconj(yval);
      if test=='T' then
        yval=conj2dis(yval);
      end
      test=isdisj(yval);
      if test=='F' then
        error ('yval should be either conjunctive or disjunctive')
      end 
      confus=classif'*yval;
      [confus_pcent,err_test,err_test_bycl,nci,nci_bycl]=conf_obs2pcent(confus,sum(yval,'r'));
    end

    // sorties  
    res_appli.ypred.d=classif;
    res_appli.ypred.i=xv1.i;
    res_appli.ypred.v='CL'+string([1:1:nbcl])';
    res_appli.ypred=div(res_appli.ypred);

    if argn(2)==3 then
      res_appli.conf_test_nobs.d=confus;
      res_appli.conf_test_nobs.i='pred_'+ yv1.v;
      res_appli.conf_test_nobs.v='ref_'+ yv1.v;
      res_appli.conf_test_nobs=div(res_appli.conf_test_nobs);
 
      res_appli.conf_test.d=confus_pcent; 
      res_appli.conf_test.i='pred_'+ yv1.v;
      res_appli.conf_test.v='ref_'+ yv1.v;
      res_appli.conf_test=div(res_appli.conf_test);
      
      res_appli.err_test.d=err_test;
      res_appli.err_test.v='error of prediction, p.cent';
      res_appli.err_test=div(res_appli.err_test);
 
      res_appli.errbycl_test.d=err_test_bycl;
      res_appli.errbycl_test.i='CL'+string([1:1:nbcl]');
      res_appli.errbycl_test=div(res_appli.errbycl_test);   
    
      res_appli.notclassed.d=nci;
      res_appli.notclassed.v='not classed, p.cent of all the observations';
      res_appli.notclassed=div(res_appli.notclassed);
    
      res_appli.notclassed_bycl.d=nci_bycl;
      res_appli.notclassed_bycl.i='CL'+string([1:1:nbcl])';
      res_appli.notclassed.v='not classed, p.cent of the number of observations of each class';
      res_appli.notclassed_bycl=div(res_appli.notclassed_bycl);
 
     end

  end
    

     
endfunction
